//  Created by Marcin Krzyzanowski
//  https://github.com/krzyzanowskim/STTextView/blob/main/LICENSE.md

import UIKit
import STTextKitPlus

extension STTextView: NSTextViewportLayoutControllerDelegate {

    public func viewportBounds(for textViewportLayoutController: NSTextViewportLayoutController) -> CGRect {
        contentView.bounds
//        let overdrawRect = preparedContentRect
//        let minY: CGFloat
//        let maxY: CGFloat
//        let minX: CGFloat
//        let maxX: CGFloat
//
//        let visibleRect = scrollView?.documentVisibleRect ?? self.visibleRect
//
//        if !overdrawRect.isEmpty, overdrawRect.intersects(visibleRect) {
//            // Use preparedContentRect for vertical overdraw and ensure visibleRect is included at the minimum,
//            // the width is always bounds width for proper line wrapping.
//            minX = min(overdrawRect.minX, max(visibleRect.minX, bounds.minX))
//            minY = min(overdrawRect.minY, max(visibleRect.minY, bounds.minY))
//            maxX = max(overdrawRect.maxX, visibleRect.maxX)
//            maxY = max(overdrawRect.maxY, visibleRect.maxY)
//        } else {
//            // We use visible rect directly if preparedContentRect does not intersect.
//            // This can happen if overdraw has not caught up with scrolling yet, such as before the first layout.
//            minX = visibleRect.minX
//            minY = visibleRect.minY
//            maxX = visibleRect.maxX
//            maxY = visibleRect.maxY
//        }
//
//        return CGRect(x: minX, y: minY, width: maxX, height: maxY - minY)
    }

    public func textViewportLayoutControllerWillLayout(_ textViewportLayoutController: NSTextViewportLayoutController) {
        // TODO: update difference, not all layers
        for subview in contentView.subviews/*.filter({ type(of: $0) != STInsertionPointView })*/ {
            subview.removeFromSuperview()
        }
    }

    public func textViewportLayoutController(_ textViewportLayoutController: NSTextViewportLayoutController, configureRenderingSurfaceFor textLayoutFragment: NSTextLayoutFragment) {
        let fragmentView = fragmentViewMap.object(forKey: textLayoutFragment) ?? STTextLayoutFragmentView(layoutFragment: textLayoutFragment, frame: .zero)
        // Adjust position
        let oldFrame = fragmentView.frame
        fragmentView.frame = textLayoutFragment.layoutFragmentFrame//.pixelAligned
        if !oldFrame.isAlmostEqual(to: fragmentView.frame)  {
            fragmentView.setNeedsLayout()
            fragmentView.setNeedsDisplay()
        }

        contentView.addSubview(fragmentView)
        fragmentViewMap.setObject(fragmentView, forKey: textLayoutFragment)
    }

    public func textViewportLayoutControllerDidLayout(_ textViewportLayoutController: NSTextViewportLayoutController) {
        contentSize = textLayoutManager.usageBoundsForTextContainer.size
        sizeToFit()
        // adjustViewportOffsetIfNeeded()

        // if let viewportRange = textViewportLayoutController.viewportRange {
        //    for events in plugins.events {
        //        events.didLayoutViewportHandler?(viewportRange)
        //    }
        // }
    }
}
